  .286

  STEJNESEG macro
    mov ax,cs
    mov ds,ax
    mov es,ax
  endm

_TEXT segment
  assume cs:_TEXT , ds:_TEXT , es:_TEXT , ss:_TEXT

  org 100h
@filename:
  jmp begin

  ticks = 9

  infolen     = 7 ; i s #0
  infoname    db 'SEZNAM',0
  jpgs        = 13
  jpg         db 'JPG'
              db 'PNG'
              db 'PCX'
              db 'BMP'
              db 'GIF'
              db 'TGA'
              db 'FLI'
              db 'FLC'
              db 'TIF'
              db 'PNM'
              db 'WPG'
              db 'ICO'
              db 'ABM'
  jpgend:

  exe         db 'EXE'
  fmask       db '\*.*'

  min_line    = 19
  max_comm    = 80
  max_name    = 9
  max_polozek = 300
;  max_polozek = 7
  delka_i     = 3+max_name+3+1+max_comm ; 3 pro cislo, 3 pro priponu, 1 pro delku popisu
  filepos     dw 0
  polindex    dw 0
  len         db 0
  ; buffery a zasobniky jsou na konci programu pro zmenseni COM-souboru

  busy        db 0
  cnt         db 0
  lastdisk    db 0FFh
  lastfile    dw 0
  vesa        db 0
  vga         db 0
  lastpage    dw 0FFFFh
  ressize     = 12
  resolut     dw 320,200,640,480,800,600,1024,768,1280,1024,1600,1200

;-----------------------------------------------------------------------------
drawinfo proc near
  cmp lastfile,0                    ; offset aktualniho popisu
  je enddraw2
  mov vga,0
  mov ah,0Fh                        ; testuj mod 320x200x256
  int 10h
  cmp al,13h
  je vga0
  mov ax,4F03h                      ; zjisti cislo modu -> BX
  int 10h
  cmp ax,004Fh
  je dalD0
  jmp enddraw
dalD0:
  cmp bx,0100h
  jb enddraw2
  cmp bx,011Bh
  ja enddraw2
  cmp bx,0107h
  jbe dalD1
  cmp bx,010Dh
  jae dalD1
enddraw2:
  jmp enddraw

vga0:
  mov vga,1
  mov bpr,320
  mov ppr,320
  mov lps,200
  mov bpp,1
  jmp dalD2

dalD1:                              ; je to graficky VESAmod
  mov ax,4F06h                      ; zjisti delku log. scanu
  mov bl,01h
  int 10h
  cmp ax,004Fh
  je dalD4
  jmp enddraw
dalD4:
  mov bpr,bx                        ; bytes per row
  mov ppr,cx                        ; pixels per row
vga1:
  xor dx,dx
  mov ax,bx
  div cx
  mov bpp,ax                        ; bytes per pixel

  mov di,offset resolut             ; najdeme Y-rozmer v tabulce
  mov ax,cx
  mov cx,ressize
  cld
  repnz scasw
  jnz enddraw2
  mov dx,[di]
  mov lps,dx

  cmp lastpage,0FFFFh               ; jeste nikdo nenastavoval stranku ?
  je enddraw2
dalD2:

  mov ax,bpr                        ; vypocet velikosti obrazovky -> DX,AX
  mul lps                           ; ( DX = pocet stranek-1 (=posl.stranka))
  mov bx,ax                         ; ulozit offset konce na posl.strance

  push dx
  mov ax,bpr
  mov cx,14
  mul cx                            ; AX = o kolik bytu zpet (14 radek)
  sub bx,ax
  mov cx,dx
  pop dx

  sbb dx,cx                         ; pokud CF=1, sniz DX na predposledni stranku
                                    ; nastav (pred)posledni stranku
  mov lineofs,bx                    ; ofset zacatku prvni radky
  mov pagecnt,dx                    ; cislo aktivni stranky
  cmp vga,1
  je dalD3
  xor bx,bx
  call dword ptr switch
dalD3:

  xor ax,ax                         ; stavove klavesy do DX
  mov es,ax
  mov dx,word ptr es:[0417h]
  push cs
  pop es

  mov di,lastfile
  xor ch,ch
  mov cl,[di]                       ; v CX je delka popisu
  mov realend,cx                    ; v realend take
  test dx,40h
  jz nofill                         ; je vypnut Caps lock ?
  mov cl,maxlen                     ; ne - tak je delka maximalni
 nofill:
  push cx                           ; Pozor ! - vybira se nize jako AX
  mov charstart,cx
  inc di
  add realend,di
  inc realend
  mov linestart,di
  mov al,'\'
; @@@                               ; dalsi upravy jsou pro prohledavani
  add di,cx                         ; pozpatku @@@
  dec di
  std

  repne scasb                       ; je v popisu '\' ?
; @@@
  cld

  jne neni
  test dx,10h
  jnz color                         ; je nastaven Scroll lock ?
; @@@
  add di,2

  mov linestart,di
  test dx,40h                       ; je nastaven Caps lock ?
  jnz neni
 color:

;  mov charstart,cx
; @@@
  inc cx
  sub charstart,cx

 neni:
  mov si,lastfile
  pop ax                            ; v AX delka popisu
  test dx,40h
  jne fill                          ; je vypnut Scroll lock ?
  add ax,lastfile
  sub ax,linestart
  inc ax
 fill:
  shl ax,3                          ; vynasobit 8
  mov bx,ppr
  sub bx,ax

  jnc dalD5                         ; Kdyz tak popis zkratit
  mov ax,ppr                        ; ( kdyz se nevejde na obrazovku )
  not bx
  shr bx,3
  sub charstart,bx                  ; zaroven upravime i zacatek zvyrazneni
  xor bx,bx
dalD5:
  mov lenp,ax
  shr lenp,3

  shr bx,1                          ; v BX pocet pixelu od kraje k zacatku textu
  mov ax,bx
  mul bpp                           ; v AX pocet bytu od kraje k zacatku textu
  mov startofs,ax

;  mov ax,1130h                      ; ES:BP <- adresa ROM-fontu 14x8
;  mov bh,2                          ;  -> CharSeg
;  int 10h
;  mov CharSeg,es

;  mov CharSeg,ds                   ; jen pro tabulku mimo program
  mov bp,offset Latin2

  mov dl,byte ptr bpp

  mov ax,0A000h                     ; ES - obrazovka
  mov es,ax

  mov rc,0
  mov di,lineofs
  add di,startofs
  cmp lenp,max_comm
  jne dalsi_radka
  jmp konec_dr
dalsi_radka:
  mov si,linestart
  mov cx,lenp
 dalsi_znak:
   push cx                          ; zmenit barvu na modrou ?
   mov const16,0FFFFh
   mov const24,0FFFFh
   cmp cx,charstart
   jbe bila
   mov const16,0001Fh
   cmp dl,2
   je bila
   shl const16,3
   inc const24
  bila:
   lodsb
   cmp si,realend                   ; za koncem popisu mezeru
   jb nonul
   mov al,20h
  nonul:
   mov cl,14
   mul cl
   mov bx,ax

   push ds

;   mov ds,CharSeg                  ; jen pro tabulku mimo program
   add bx,bp
   mov cl,byte ptr ds:[bx]
   mov ch,0

   call bod

   pop ds
   pop cx

  loop dalsi_znak

  inc bp                            ; dalsi radek znaku v tabulce
  mov ax,startofs
  shl ax,1
  mov cx,di
  add di,ax                         ; offset pro zacatek dalsi radky zvysime
  not ax
  cmp ax,cx
  jae neprepinej1                   ; preteceni do dalsiho segmentu
   cmp cs:[vga],1
   je neprepinej1
   push dx                          ;  -> nutno zmenit stranku
   inc word ptr [pagecnt]
   mov dx,[pagecnt]
   xor bx,bx
   call dword ptr switch
   pop dx
 neprepinej1:

  inc rc
  cmp rc,14
  jnb konec_dr
  jmp dalsi_radka
konec_dr:
                                    ; nastav cislo stranky zpet
  cmp vga,1
  je enddraw

  xor bx,bx
  mov dx,lastpage
  call dword ptr switch

enddraw:
  ret
drawinfo endp

bod proc near
  dalsi_bod:
    xor ax,ax                       ; nuluj AX
    shl cl,1                        ; nejvyssi bit do CF
    sbb ax,0                        ; pokud je CF=1, odecti od AX 1
    cmp dl,1                        ; DL = bytu na pixel
    je d256
    and ax,const16
    stosw
    cmp dl,2
    je db_konec
    and ax,const24
    stosw
    jmp db_konec
   d256:
    stosb
   db_konec:
    cmp di,0
    jne neprepinej2
    cmp cs:[vga],1
    je neprepinej2
    push dx
    inc word ptr cs:[pagecnt]
    mov dx,cs:[pagecnt]
    xor bx,bx
    call dword ptr cs:[switch]
    pop dx
   neprepinej2:
    inc ch
    cmp ch,8
    jne dalsi_bod
    ret
bod endp

;-----------------------------------------------------------------------------
Int1C proc far
  assume cs:_TEXT , ds:_TEXT , es:_TEXT , ss:_TEXT
  pushf
  call dword ptr cs:[ofs_1C]
  push ax
  mov al,20h
  out 20h,al
  pop ax

  cmp cs:[busy],0
  jne nic1C

  mov cs:[busy],1

  sti

  inc byte ptr cs:[cnt]
  cmp byte ptr cs:[cnt],ticks
  jb end1C
  mov byte ptr cs:[cnt],0
  mov word ptr cs:[p_ax],ax
  mov word ptr cs:[SPtr],sp          ; ulozit stary zasobnik
  mov word ptr cs:[SSeg],ss
  mov ax,cs
  cli                                ; Prepnout zasobnik
  mov ss,ax
  mov sp,offset ENDSTACK
  sti
  push ds        ;+14                ; Uschovam do nej registry
  push es        ;+12
  push si        ;+10
  push di        ;+8
  push dx        ;+6
  push cx        ;+4
  push bx        ;+2
  push bp        ;+0
  mov bp,sp
  mov cs:[StackSave],bp
  STEJNESEG

  call drawinfo                     ; ! Hlavni procedura !

  pop bp
  pop bx                            ; Obnovim registry
  pop cx
  pop dx
  pop di
  pop si
  pop es
  pop ds
  cli                               ; Zasobnik zpet
  mov ss,cs:[SSeg]
  mov sp,cs:[SPtr]
  sti
  mov ax,cs:[p_ax]
end1C:
  mov cs:[busy],0

  cli

nic1C:
  iret
Int1C endp

  ofs_1C      dw ?
  seg_1C      dw ?

;-----------------------------------------------------------------------------
int10 proc far
  pushf
  cmp busy,1
  je end_10
  cmp ax,4F01h
  je int_10_01
  cmp ax,4F05h
  je int_10_05
  jmp end_10

 int_10_01:
  call dword ptr cs:[ofs_10]
                                    ; nastavit adresu prepinaci fce
  mov word ptr es:[di+12  ],offset Myswitch
  mov word ptr es:[di+12+2],cs

  iret

 int_10_05:
  cmp bh,00h
  jne end_10

  call dword ptr cs:[ofs_10]

  cmp ax,004Fh
  jne sperr
  mov cs:[lastpage],dx
 sperr:
  iret

end_10:
  popf
  db 0EAh
int10 endp
  ofs_10      dw ?
  seg_10      dw ?

Myswitch proc far
  mov cs:[s_dx],dx
  call dword ptr cs:[switch]
  pushf
  cmp ah,0
  jne mserr
  push dx
  mov dx,cs:[s_dx]
  mov cs:[lastpage],dx
  pop dx
 mserr:
  popf
  ret
Myswitch endp

;-----------------------------------------------------------------------------
upcase proc near
                               ; Upcase    ES:DI - odkud
                               ;              CX - kolik
Uloop:                         ;    ! meni DI,CX
  mov al,byte ptr es:[di]
  cmp al,61h
  jb Unext
  cmp al,7Ah
  ja Unext
  and byte ptr es:[di],0DFh
Unext:
  inc di
  loop Uloop
Uend:
  ret
upcase endp

;-----------------------------------------------------------------------------
Search proc near
  mov bx,0                          ; Hledani tecky od DS:SI dal
loop2:                              ; BX := offset posledniho vyskytu pred #0
  cmp byte ptr ds:[si],'.'          ; Kdyz tam zadna tecka neni ? BX:=0
  jne dal_t
  mov bx,si
dal_t:
  inc si
  cmp byte ptr ds:[si],0
  jne loop2
  ret
Search endp

;-----------------------------------------------------------------------------
Readline proc near                 ; BX - file handle, nesmi zmenit
                                    ; DS:DX - linebuff, dost mista pro 256 B
                                    ; -> vraci delku v CX
                                    ; ! pouziva SI,DI a ds:[filepos]
                                    ; jen do 64 KB velikosti souboru !
  mov ah,3Fh                        ; cist 256 byte na DS:DX
  mov cx,256

  pushf
  call dword ptr cs:[ofs_21]

  jc RLerror

  cmp ax,2                          ; uz rozhodne zadna radka delsi nez 0
  jbe RLeof

  mov cx,ax                         ; v CX skutecna delka nactenych dat
                                    ; hledame 0A0Dh
  mov si,dx
RLloop:
  lodsw                             ; DS:SI -> AX ; zaroven add si,2
  cmp ax,0A0Dh
  je RLnalezeno
  dec si
  loop RLloop                       ; sniz CX a vrat se pokud <> 0

                                    ; prilis dlouha radka
  stc                               ; CF -> true
  ret

RLnalezeno:
                                    ; ted je na DS:[SI-2] 0A0Dh
  sub si,dx                         ; v SI delka radky i s CR,LF

  mov cx,0                          ; presuneme ukazatel zpet
  mov dx,ds:[filepos]
  add dx,si                         ; DX = predch. posice + delka radky + 2
  mov word ptr ds:[filepos],dx      ;      ( to je nova posice )
  mov ax,4200h                      ;      pocitano od zacatku souboru
  pushf
  call dword ptr cs:[ofs_21]

  mov cx,si                         ; ulozime o 2 snizenou delku do CX
  sub cx,2
RLend:
  mov al,0
  clc                               ; CF -> false
  ret

RLerror:
  mov al,1                          ; CF -> false, AL -> 1 - chyba pri cteni
  clc
  ret

RLeof:
  xor cx,cx                         ; delka radky = 0
  jmp RLend

Readline endp

;-----------------------------------------------------------------------------
extract proc near
  push cx                           ; ulozime si delku radky
  add word ptr ds:[polindex],delka_i; dalsi polozka
  mov di,offset seznam-delka_i      ; ES:DI - akt. polozka
  add di,word ptr ds:[polindex]

  push di                           ; ulozime pro budouci potrebu (4x)
  push di
  push di
  push di
                                    ;--------- kopie cisla ------------
  mov si,offset fdata               ; DS:SI - fdata, 0 znaku od zacatku
  mov cx,3
  cld
  rep movsb
                                    ;--------- kopie jmena ------------
  mov si,offset fdata+5             ; DS:SI - fdata, 5 znaku od zacatku
  mov cx,8+1+3
  rep movsb                         ; kopie jmena

  pop di                            ; obnovit DI
  add di,3
  mov cx,8+1+3
  call Upcase                       ; Upcase i s priponou

  pop di                            ; obnovit DI
  add di,3                          ;  a zvysit o 3
  mov al,'.'                        ; najdeme tecku
  mov cx,9                          ; muze byt i na 9. miste
  cld
  repnz scasb
  dec di
  mov byte ptr [di],0               ;  a zmenime na nulu

  mov si,di                         ; pripona se bude posouvat pozpatku
  add si,3
  pop di
  add di,3+max_name+2               ; DI - v tabulce na miste KONCE pripony
  std
  mov cx,3
  rep movsb
  cld
                                    ;--------- kopie popisu -----------
  pop di                            ; obnovit DI
  add di,3+max_name+3               ;  a zvysit o 3+8+3
  pop cx                            ; obnovime do CX delku radky
  sub cx,18                         ; zkratime, ted je to delka popisu
  cmp cx,max_comm
  jbe neni_delsi                    ; neni delsi nez max. pov. popis ?
  mov cx,max_comm                   ; je - zkratime
 neni_delsi:
  mov al,cl                         ;  a ulozime na jeji misto na zacatku
  stosb                             ;   (za zvyseni DI)
  cmp al,maxlen                     ; test na nejdelsi popis
  jbe norecord
  mov maxlen,al
 norecord:
  mov si,offset fdata+18            ; DS:SI - fdata, 18 znaku od zacatku
  cld
  rep movsb                         ; a zkopirujeme
  mov ah,0                          ; jeste doplnime mezerami
  sub ax,max_comm+1
  not ax
  mov cx,ax
  mov al,' '
  rep stosb
  ret
extract endp

;-----------------------------------------------------------------------------
ReadInfo proc near                  ; ! na DS:SI je cesta se jmenem,#0
  mov ds:[polindex],0
  mov ds:[lastfile],0
  mov maxlen,0
  mov ax,6C00h                      ; otevrit soubor pro cteni
  mov dx,0001h                      ; jen pokud existuje
  mov bx,2000h                      ; obejit INT 24h
  pushf
  call dword ptr cs:[ofs_21]
  jnc dalRI
  ret
dalRI:
  mov bx,ax                         ; BX - handle !
  mov filepos,0
loopRI:
  mov dx,offset Fdata
  call Readline
  jc RIerror
  cmp al,1
  je close
                                    ; nova radka
  cmp cx,min_line                   ; neni moc kratka
  jb close                          ;   - koncime, konec souboru ?

  call extract

  cmp ds:[polindex],max_polozek*(delka_i)
  jb loopRI

close:
  mov ah,3Eh
  pushf
  call dword ptr cs:[ofs_21]
  ret

RIerror:
  mov ds:[polindex],0
  jmp close

Readinfo endp
;-----------------------------------------------------------------------------
Active proc near
  mov ax,cs:[p_ax]

  cmp ah,04Eh
  je Find4E
  cmp ah,04Fh
  je Find4F2
  cmp ah,03Bh
  je ChDir3B
  cmp ah,00Eh
  je ChDir0E
  cmp ah,043h
  je open2
  cmp ah,03Dh
  je open2
  jmp konec_act
Find4F2:
  jmp Find4F
Open2:
  jmp Open

Chdir3B:
  call Puvodni21                    ; Puvodni obsluhu

  mov si,offset infoname
  call Readinfo

  ret

Chdir0E:
  mov dx,ss:[bp+6]   ; DX
  push dx

  call Puvodni21                    ; Puvodni obsluhu

  pop dx

  cmp dl,ds:[lastdisk]              ; cist, jen kdyz se zmenil disk
  je necti
  cmp ds:[lastdisk],0FFh
  mov ds:[lastdisk],dl
  je necti
  mov si,offset infoname
  call Readinfo
necti:
  ret

Find4E:
  push es

  mov es,ss:[bp+14]  ; DS
  mov di,ss:[bp+6]   ; DX
  mov al,0                          ; ES - preruseny segment
  mov cx,80                         ; DS - nas segment
  cld
  repnz scasb
  jnz end_4E
  sub di,5

  mov dx,di          ; delka retezce -> DX
  sub dx,ss:[bp+6]   ; DX (puvodni )
  inc dx             ; i s '\'

  mov si,offset fmask               ; '\*.*'
  mov cx,4
  cld
  repe cmpsb
  jne end_4E                        ; nekonci *.* - pryc

  pop es
  push es                           ; pro POP DS -->>
  mov ds,ss:[bp+14]  ; DS
  mov si,ss:[bp+6]   ; DX
  mov di,offset fdata               ; ES - nas segment
  mov cx,dx                         ; DS - preruseny segment
  cld
  rep movsb
  pop ds                            ; DS - take nas
  mov si,offset infoname
  mov cx,infolen
  rep movsb
  push es

  mov si,offset fdata
  call Readinfo                     ; a nacist nove udaje z tohoto adresare

 end_4E:
  pop es

Find4F:
  call Puvodni21                    ; Puvodni obsluhu

                                    ; Zjisteni stareho DTA -> ES:BX
  mov bx,word ptr cs:[SDTA]
  mov es,word ptr cs:[SDTA+2]
  push es
  pop ds
  mov si,bx
  add si,1Eh                        ; jmeno na offsetu 1Eh
  mov dx,si                         ; uchovame offset jmena v DX
  call Search                       ; Hledani tecky
  cmp bx,0                          ; Kdyz tam zadna tecka neni ? - ven
  je dal5                           ; skok na RET
  inc bx                            ; BX+1 - offset pripony

  mov di,dx                         ; Upcase celeho jmena
  mov cx,12
  call upcase

  push cs                           ; Je pripona mezi obrazky ?
  pop ds
  mov si,offset jpg-3
 znovuF4F:
  add si,3
  cmp si,offset jpgend
  jae dal5                          ; skok na RET
  mov di,bx
  mov cx,3
  push si
  cld
  repe cmpsb
  pop si
  jne znovuF4F
                                    ; Ano - najdi cislo
                                    ; ES - segment DTA
                                    ; DS - nas offset
  xor ax,ax
FNloop:
  mov di,dx                         ; ES:DI - jmeno '12345678.123'
  mov si,offset seznam              ; DS:SI - jmeno ze seznamu (+3)
  add si,ax                         ;                      '12345678',00h
  add si,3
  cmp ax,polindex
  ja dal5                           ; vetsi nez nejvyssi polozka ? - nemenime
  add ax,delka_i

  mov cx,8
  cld
  repe cmpsb
  je FNfound                        ; nalezeno ->
                                    ; jinak SI-1 a DI-1 = prvni nerovny znak
  cmp byte ptr ds:[si-1],00h
  jne FNloop                        ; neni to az #0 v seznamu -> dalsi jmeno
  cmp byte ptr es:[di-1],'.'
  jne FNloop                        ; neni to az '.' ve jmene -> dalsi jmeno

FNfound:
  mov di,bx                         ; v BX je porad offset pripony
  mov si,offset seznam
  add si,ax                         ; SI - offset cisla jmena
  sub si,delka_i
  mov cx,3
  cld
  rep movsb

dal5:
  ret

;-------------------------- OPEN --------------------------------------------
Open:
  mov lastfile,0

  mov ds,ss:[bp+14]  ; DS
  mov si,ss:[bp+6]   ; DX

  cmp byte ptr ds:[si],0
  jne dal7
  jmp konec_act
dal7:

  call Search                       ; Hledani tecky
  cmp bx,0                          ; Kdyz tam zadna tecka neni ? - ven
  jne dal1
  jmp konec_act
dal1:

  mov cs:[tecka],bx                  ; ulozit posici - BX je stale potreba !

  mov ax,ss:[bp+14]  ; DS
  mov ds,ax
  mov si,ss:[bp+6]   ; DX            ; Hledani znaku #0
  mov ax,0
  dec si

loop7:
  inc si
  cmp byte ptr ds:[si],0
  jne loop7
  mov word ptr cs:[konec],si         ; [konec] = offset posledniho #0

  push cs                            ; Kopie pripony - DS stale zustava puvodni
  pop es
  inc bx
  mov di,offset pripona
  mov si,bx
  mov cx,3
  cld
  rep movsb

  push cs
  pop es
  mov ax,ss:[bp+14]  ; DS            ; Hledani \/: smerem zpet
  mov ds,ax                          ; (celeho jmena)
  mov bx,ss:[bp+6]   ; DX
  mov si,cs:[konec]
loop5:
  cmp byte ptr ds:[si],'\'
  je nalezeno
  cmp byte ptr ds:[si],':'
  je nalezeno
  cmp byte ptr ds:[si],'/'
  je nalezeno
  dec si
  cmp si,bx
  jne loop5
  mov si,bx
  dec si
nalezeno:

  inc si                             ; Kopie jmena
  mov di,offset jmeno
  mov cx,cs:[tecka]
  sub cx,si
  mov cs:[delka],cl
  cld
  rep movsb
  mov byte ptr es:[di],'.'           ; Ukoncime '.'

  mov di,offset jmeno                ; Upcase
  mov cx,8
  call upcase
  mov di,offset pripona              ; Upcase
  mov cx,3
  call upcase

  push cs
  pop ds

                                    ; je to pripona obrazku ?
  mov di,offset jpg-3
 znovuF3D:
  add di,3
  cmp di,offset jpgend
  jae dal8
  mov cx,3
  mov si,offset pripona
  push di
  cld
  repe cmpsb
  pop di
  je FindName                       ; je - take hledat v tabulce
  jmp znovuF3D
 dal8:                              ; neni - hledat dal

  mov al,0
  mov si,offset pripona
dalsiP:                             ; je to .XXX ?
  cmp byte ptr ds:[si],'0'          ; ( X mezi 0-9 )
  jb konec_act
  cmp byte ptr ds:[si],'9'
  ja konec_act
  inc si
  inc al
  cmp al,3
  jb dalsiP

FindName:
                                    ; je - najdi v tabulce
  xor ax,ax
ONloop:
  mov di,offset jmeno               ; ES:DI - jmeno '12345678','.'
  mov si,offset seznam              ; DS:SI - jmeno ze seznamu (+3)
  add si,ax                         ;                      '12345678',00h
  add si,3
  cmp ax,polindex
  ja dalON                          ; vetsi nez nejvyssi polozka ? - nenalezeno
  add ax,delka_i

  mov cx,8
  cld
  repe cmpsb
  je ONfound                        ; nalezeno ->
  dec si                            ; jinak SI-1 = prvni nerovny znak
  dec di

  cmp byte ptr ds:[si],00h
  jne ONloop                        ; neni to az #0 -> dalsi jmeno
  cmp byte ptr es:[di],'.'
  jne ONloop                        ; neni to az '.' -> dalsi jmeno

ONfound:
  mov si,offset seznam-delka_i
  add si,ax                         ; SI - offset cisla jmena
  mov bx,si                         ; offset popisu pro budouci potrebu
  add si,15                         ; SI - offset popisu (+ 15d)
  mov lastfile,si
           ; ulozit offset popisu posledniho oteviraneho souboru

; !!!!!!!!!1 dalON:
                                    ; a zamen za puvodni priponu obrazku
  mov ax,ss:[bp+14]  ; puv. DS -> ES
  mov es,ax
  mov di,ds:[tecka]
  inc di
;  mov si,offset jpg
  mov si,bx
  add si,3+max_name
  mov cx,3
  cld
  rep movsb

dalON:

konec_act:

  call Puvodni21

  ret
Active endp

;-----------------------------------------------------------------------------
Puvodni21 proc near

  call vrat_PSPaDTA

  mov ax,word ptr cs:[SSeg]         ; Puvodni Flags
  mov ds,ax                         ; (ulozene na starem zasobniku)
  mov si,word ptr cs:[SPtr]         ; do AX
  mov ax,word ptr ds:[si+6]

  mov bp,cs:[StackSave]
  mov bx,cs:[bp+2]
  mov cx,cs:[bp+4]
  mov dx,cs:[bp+6]
  mov di,cs:[bp+8]
  mov si,cs:[bp+10]
  mov es,cs:[bp+12]
  mov ds,cs:[bp+14]
  mov bp,cs:[bp+0]

  push ax                           ; Ted jako Flags

  mov ax,cs:[p_ax]

  call dword ptr cs:[ofs_21]        ; Puvodni obsluha

  push bx
  pushf
  pop bx

  mov cs:[p_ax],ax
  push ds
  push si
  mov ax,cs:[SSeg]                  ; Nove Flags vratime zpet
  mov ds,ax
  mov si,cs:[SPtr]
  mov word ptr ds:[si+6],bx
  pop si
  pop ds

  pop bx

  push bp
  mov bp,cs:[StackSave]
  mov cs:[bp+2],bx
  mov cs:[bp+4],cx
  mov cs:[bp+6],dx
  mov cs:[bp+8],di
  mov cs:[bp+10],si
  mov cs:[bp+12],es
  mov cs:[bp+14],ds
  pop ax                            ; ted jako BP
  mov cs:[bp+0],ax

  STEJNESEG

  call uloz_a_nastav_PSPaDTA

  ret

Puvodni21 endp

;-----------------------------------------------------------------------------
Int21 proc far
  assume cs:_TEXT , ds:_TEXT , es:_TEXT , ss:_TEXT
  pushf
  cmp cs:[busy],0
  jne nic21
  mov cs:[busy],1

  cmp ah,3Dh
  je dal21
  cmp ah,4Eh
  je dal21
  cmp ah,4Fh
  je dal21
  cmp ah,0Eh
  je dal21
  cmp ah,3Bh
  je dal21
  cmp ah,43h
  je dal21
  jmp nic21

dal21:
  mov word ptr cs:[p_ax],ax
  mov word ptr cs:[SPtr],sp          ; ulozit stary zasobnik
  mov word ptr cs:[SSeg],ss
;  pop ax ; -- Proc ?
  mov ax,cs
  cli                                ; Prepnout zasobnik
  mov ss,ax
  mov sp,offset ENDSTACK
  sti
  push ds        ;+14                ; Uschovam do nej registry
  push es        ;+12
  push si        ;+10
  push di        ;+8
  push dx        ;+6
  push cx        ;+4
  push bx        ;+2
  push bp        ;+0
  mov bp,sp
  mov cs:[StackSave],bp
  STEJNESEG

  call uloz_a_nastav_PSPaDTA

  call active                       ; ! Hlavni procedura !

  call vrat_PSPaDTA

  pop bp
  pop bx                            ; Obnovim registry
  pop cx
  pop dx
  pop di
  pop si
  pop es
  pop ds
  cli                               ; Zasobnik zpet
  mov ss,cs:[SSeg]
  mov sp,cs:[SPtr]
  add sp,2                          ; misto POPF - Flags se zmenily
  sti
  mov ax,cs:[p_ax]
  mov cs:[busy],0
  iret

nic21:
  mov cs:[busy],0
  popf
  db 0EAh                           ; zavolat beze zmeny
Int21 endp
  ofs_21      dw ?
  seg_21      dw ?

;-----------------------------------------------------------------------------
uloz_a_nastav_PSPaDTA proc near
  push dx
  push ax
  push bx
  push ds
  push es
  mov ah,51h                        ; zjisti a uloz PSP
  pushf
  call dword ptr cs:[ofs_21]
  mov cs:[SPSP],bx

  mov ah,50h                        ; nastav nase PSP
  mov bx,cs:[MyPSP]
  pushf
  call dword ptr cs:[ofs_21]

  mov ah,2Fh                        ; zjisti a uloz DTA
  pushf
  call dword ptr cs:[ofs_21]
  mov word ptr cs:[SDTA],bx
  mov word ptr cs:[SDTA+2],es

  mov ah,1Ah                        ; nastav nase DTA
  mov dx,word ptr cs:[MyDTA]
  mov ds,word ptr cs:[MyDTA+2]
  pushf
  call dword ptr cs:[ofs_21]
  pop es
  pop ds
  pop bx
  pop ax
  pop dx
  ret
uloz_a_nastav_PSPaDTA endp
;-----------------------------------------------------------------------------
vrat_PSPaDTA proc near
  push dx
  push ax
  push bx
  push ds
  mov ah,50h                        ; vrat puvodni PSP
  mov bx,cs:[SPSP]
  pushf
  call dword ptr cs:[ofs_21]

  mov ah,1Ah                        ; vrat puvodni DTA
  mov dx,word ptr cs:[SDTA]
  mov ds,word ptr cs:[SDTA+2]
  pushf
  call dword ptr cs:[ofs_21]
  pop ds
  pop bx
  pop ax
  pop dx
  ret
vrat_PSPaDTA endp

;-----------------------------------------------------------------------------
begin proc near
  assume cs:_TEXT , ds:_TEXT , es:_TEXT , ss:_TEXT
  STEJNESEG

  mov sp,offset endstackNR

  mov ah,4Ah                        ; Zmensi blok pameti
  mov bx,(offset program_end - offset _TEXT + 15) shr 4
  int 21h
                                    ; ------ Zjisti adresar s programem ------

  push ds
  mov ax,word ptr ds:[2Ch]          ; AX - segment prostredi DOSu
  mov ds,ax                         ;    -> DS
  xor si,si                         ; hledame 0000h od zacatku
  mov cx,0FFFFh                     ; maximalne FFFFh bytu
FAloop:
  lodsw                             ; DS:SI -> AX ; zaroven add si,2
  cmp ax,0000h
  je FAnalezeno
  dec si
  loop FAloop                       ; sniz CX a vrat se pokud <> 0
  jmp konec_prog
FAnalezeno:
  add si,2                          ; zkopirujeme z DS:SI na ES(nase):[EXEfile]
  mov di,offset EXEfile
  mov cx,80
  cld
  rep movsb
  mov di,offset EXEfile             ; Upcase
  mov cx,80
  call upcase

  pop ds                            ; obnov nase DS

  mov si,offset EXEfile
  call Search                       ; najdi tecku
  cmp bx,0
  jne dal9
  jmp konec_prog
dal9:
  inc bx
  mov di,bx
  mov si,offset exe                 ; zmen priponu na .EXE
  mov cx,3
  cld
  rep movsb
  mov ax,2400h                      ; pridat jeste 00 a $
  stosw
                                    ; ------ vypis informace ------
  mov dx,offset Info1
  mov ah,09h
  int 21h
  mov dx,offset EXEfile
  mov ah,09h
  int 21h
  mov dx,offset Info2
  mov ah,09h
  int 21h
                                    ; zkopirovat parametry na CMDpar za EXEfile
  mov al,20h                        ; mezera pred parametry
  stosb
  mov si,81h
  xor ch,ch
  mov cl,byte ptr ds:[80h]          ; delka parametru
  rep movsb
  mov ax,di
  sub ax,offset CMDpar
  dec ax
  mov ds:[CMDpar],al                ; delka parametru i se jmenem programu
  mov word ptr ds:[CMDpar+1],'/'+100h*'C'
  mov ax,000Dh
  stosw
                                    ; ------ Zjisti COMSPEC ------

  push ds
  mov ax,word ptr ds:[2Ch]          ; AX - segment prostredi DOSu
  mov ds,ax                         ;    -> DS
  xor si,si                         ; hledame od zacatku
loopC:
  mov di,offset comspec
  mov cx,7
  cld
  rep cmpsb
  je nalezenoC
 loopC1:                            ; najdeme #0
  lodsb
  cmp al,0
  jne loopC1
  cmp byte ptr [si],0                        ; konec prostredi
  jne loopC
  mov si,offset CMDfile-1           ; nenalezeno - std.hodnota
nalezenoC:                          ; nalezeno
  inc si
  pop ds
  mov CMDofs,si

;  mov ax,word ptr ds:[2Ch]          ; ------- Uvolni prostredi
;  mov es,ax
;  mov ah,49h
;  int 21h

  mov ax,4F01h                ; zjisti adresu sluzby pro prepinani stranek
  mov cx,0100h
  mov di,offset fdata
  int 10h
  cmp ax,004Fh
  jne no_vesa
  mov vesa,1
  mov ax,word ptr [fdata+12]
  mov word ptr [switch],ax
  mov ax,word ptr [fdata+12+2]
  mov word ptr [switch+2],ax
no_vesa:

  mov ah,2Fh                        ; zjisti a uloz nase DTA
  int 21h
  mov word ptr ds:[MyDTA],bx
  mov word ptr ds:[MyDTA+2],es

  mov ah,51h                        ; zjisti a uloz nase PSP
  int 21h
  mov ds:[MyPSP],bx

  mov ax,351Ch                      ; Zjistit INT 1Ch
;  mov ax,3508h
  int 21h
  mov word ptr [ofs_1C],bx
  mov word ptr [seg_1C],es

  mov dx,offset Int1C               ; Nastavit INT 1Ch
  mov ax,251Ch
;  mov ax,2508h
  int 21h

  mov ax,3510h                      ; Zjistit INT 10h
  int 21h
  mov word ptr [ofs_10],bx
  mov word ptr [seg_10],es

  mov dx,offset Int10               ; Nastavit INT 10h
  mov ax,2510h
  int 21h

  mov ax,3521h                      ; Zjistit INT 21h
  int 21h
  mov word ptr [ofs_21],bx
  mov word ptr [seg_21],es

  mov dx,offset Int21               ; Nastavit INT 21h
  mov ax,2521h
  int 21h

  push cs
  pop es

  mov si,offset infoname
  call readinfo

  mov [SPtrNr],sp

  mov ds:[EXEpar+4],ds              ; spustit SEA
  mov ax,ds
  mov es,ax

  mov dx,CMDofs
  cmp dx,offset CMDfile
  je nemen_ds
  mov ax,word ptr ds:[2Ch]          ; AX - segment prostredi DOSu
  mov ds,ax                         ;    -> DS
nemen_ds:

  mov bx,offset EXEpar
  mov ax,4B00h

;  pushf
;  call dword ptr cs:[ofs_21]
  int 21h

  jnc dal
                                    ; Chyba pri spusteni
  mov al,0                          ; v jmene zmenime #0 na 13,10,'$'
  mov di,offset EXEfile
  mov cx,80
  cld
  repnz scasb                       ; urcite se to najde
  mov word ptr [di-1],0A0Dh
  mov word ptr [di+1],'$'

  mov ax,cs
  mov ds,ax

  mov dx,offset errr
  mov ah,09h
  int 21h
  mov dx,offset EXEfile
  mov ah,09h
  int 21h

Dal:
  STEJNESEG
  mov ss,ax

  mov sp,cs:[SPtrNR]
  mov dx,cs:[ofs_21]                ; Vratit INT 21h
  mov ax,cs:[seg_21]
  mov ds,ax
  mov ax,2521h

;  pushf
;  call dword ptr cs:[ofs_21]
  int 21h

  mov dx,cs:[ofs_1C]                ; Vratit INT 1Ch
  mov ax,cs:[seg_1C]
  mov ds,ax
  mov ax,251Ch
;  mov ax,2508h

  int 21h

  mov dx,cs:[ofs_10]                ; Vratit INT 10h
  mov ax,cs:[seg_10]
  mov ds,ax
  mov ax,2510h
  int 21h

  mov ah,1Ah                        ; vrat nase DTA
  mov dx,word ptr cs:[MyDTA]
  mov ds,word ptr cs:[MyDTA+2]
  int 21h

  push cs
  pop ds

konec_prog:
  mov ax,4C00h
  int 21h

begin endp

EXEpar      dw 0,offset CMDpar,0,0,0,0,0

errr        db 'Error executing $'
info1       db 13,10,'Picture comment viewer - (C) Oto Valek',13,10,'Executing $'
info2       db 13,10,13,10,'$'
COMSPEC     db 'COMSPEC'
CMDofs      dw ?
CMDfile     db 'C:\COMMAND.COM',0
Latin2      db 3584 dup (?)
CMDpar      db 3 dup(?)     ; ?,'/C' nahraje se po spusteni
EXEfile     db 160  dup (?) ; muze byt i ?

SPtrNR      dw ?
SPtr        dw ?
Sseg        dw ?
MyPSP       dw ?
SPSP        dw ?
MyDTA       dd ?
SDTA        dd ?
StackSave   dw ?
p_ax        dw ?

tecka       dw ?
konec       dw ?

switch      dd ?
bpr         dw ?
ppr         dw ?
lps         dw ?
bpp         dw ?
pagecnt     dw ?
s_dx        dw ?
; CharSeg     dw ?  ; jen pro tabulku mimo program
startofs    dw ?
lineofs     dw ?
linestart   dw ?
charstart   dw ?
lenp        dw ?
const16     dw ?
const24     dw ?
realend     dw ?
maxlen      db ?
delka       db ?
rc          db ?
jmeno       db 9 dup (?) ; '12345678.'
pripona     db 3 dup (?) ; '123'

  _Stack    db 256  dup (?)
Endstack:
  _StackNR  db 256  dup (?)
EndstackNR:
fdata       db 256  dup (?)
seznam      db max_polozek*(delka_i) dup (?)

program_end:

_TEXT ends
END @filename
